|  | Home · All Classes · Main Classes · Grouped Classes · Modules · Functions |

# QStyleOptionMenuItem Class Reference
[QtGui module]

The QStyleOptionMenuItem class is used to describe the parameter necessary for drawing a menu item. More...

    #include <QStyleOptionMenuItem>

Inherits QStyleOption.

- List of all members, including inherited members

### Public Types

- enum CheckType { NotCheckable, Exclusive, NonExclusive }
- enum MenuItemType { Normal, DefaultItem, Separator, SubMenu, ..., EmptyArea }

### Public Functions

- QStyleOptionMenuItem ()
- QStyleOptionMenuItem ( const QStyleOptionMenuItem & other )

- 2 public functions inherited from QStyleOption

### Public Variables

- CheckType checkType
- bool checked
- QFont font
- QIcon icon
- int maxIconWidth
- bool menuHasCheckableItems
- MenuItemType menuItemType
- QRect menuRect
- int tabWidth
- QString text

- 7 public variables inherited from QStyleOption

### Static Public Members

- const int Type
- const int Version

- 2 static public members inherited from QStyleOption

## Detailed Description

The QStyleOptionMenuItem class is used to describe the parameter necessary for drawing a menu item.

The QStyleOptionMenuItem is used for drawing menu items from QMenu. It is also used for drawing other menu-related widgets.

## Member Type Documentation

### enum QStyleOptionMenuItem::CheckType

These enums are used to indicate whether or not a check mark should be drawn for the item, or even if it should be drawn at all.

Constant | Value | Description
--- | --- | ---
`QStyleOptionMenuItem::NotCheckable` | `0` | The item is not checkable.
`QStyleOptionMenuItem::Exclusive` | `1` | The item is an exclusive check item (like a radio button).
`QStyleOptionMenuItem::NonExclusive` | `2` | The item is a non-exclusive check item (like a check box).

See also QAction::checkable, QAction::checked, and QActionGroup::exclusive.

### enum QStyleOptionMenuItem::MenuItemType

These values indicate the type of menu item that the structure describes.

Constant | Value | Description
--- | --- | ---
`QStyleOptionMenuItem::Normal` | `0` | A normal menu item.
`QStyleOptionMenuItem::DefaultItem` | `1` | A menu item that is the default action as specified with QMenu::defaultAction().
`QStyleOptionMenuItem::Separator` | `2` | A menu separator.
`QStyleOptionMenuItem::SubMenu` | `3` | Indicates the menu item points to a sub-menu.
`QStyleOptionMenuItem::Scroller` | `4` | A popup menu scroller (currently only used on Mac OS X).
`QStyleOptionMenuItem::TearOff` | `5` | A tear-off handle for the menu.
`QStyleOptionMenuItem::Margin` | `6` | The margin of the menu.
`QStyleOptionMenuItem::EmptyArea` | `7` | The empty area of the menu.

## Member Function Documentation

### QStyleOptionMenuItem::QStyleOptionMenuItem ()

Constructs a QStyleOptionMenuItem. The members variables are initialized to default values.

### QStyleOptionMenuItem::QStyleOptionMenuItem ( const QStyleOptionMenuItem & other )

Constructs a copy of the other style option.

## Member Variable Documentation

### const int QStyleOptionMenuItem::Type

Equals SO_MenuItem.

### const int QStyleOptionMenuItem::Version

Equals 1.

### CheckType QStyleOptionMenuItem::checkType

This variable holds the type of checkmark of the menu item.

See also CheckType.

### bool QStyleOptionMenuItem::checked

This variable holds whether the menu item is checked or not.

### QFont QStyleOptionMenuItem::font

This variable holds the font used for the menu item text.

This is the font that should be used for drawing the menu text minus the shortcut. The shortcut is usually drawn using the painter's font.

### QIcon QStyleOptionMenuItem::icon

This variable holds the icon for the menu item.

### int QStyleOptionMenuItem::maxIconWidth

This variable holds the maximum icon width for the icon in the menu item.

This can be used for drawing the icon into the correct place or properly aligning items. The variable must be set regardless of whether or not the menu item has an icon.

### bool QStyleOptionMenuItem::menuHasCheckableItems

This variable holds whether the menu as a whole has checkable items or not.

If this option is set to false, then the menu has no checkable items. This makes it possible for GUI styles to save some horizontal space that would normally be used for the check column.

### MenuItemType QStyleOptionMenuItem::menuItemType

This variable holds the type of menu item.

See also MenuItemType.

### QRect QStyleOptionMenuItem::menuRect

This variable holds the rectangle for the entire menu.

### int QStyleOptionMenuItem::tabWidth

This variable holds the tab width for the menu item.

The tab width is the distance between the text of the menu item and the shortcut.

### QString QStyleOptionMenuItem::text

This variable holds the text for the menu item.

Note that the text format is something like this "Menu text\tShortcut".

If the menu item doesn't have a shortcut, it will just contain the menu item's text.